<template>
    <div>
        <slot name="input" v-bind="ctx">
            <label>
              <slot name="label" v-if="label">
                {{ label }}
              </slot>
              <small v-if="desc && descPosition === 'top'"> {{ desc }} </small>
              <component :is="ctx.component" :ctx="ctx" v-on="listeners">
                  <slot v-bind="ctx"></slot>
              </component>
              <small v-if="desc && descPosition === 'bottom'"> {{ desc }} </small>
            </label>
        </slot>
    </div>
</template>

<script>
import ctx from './libs/ctx'
import { has, objEquals } from './libs/utils'

export default {
  name: 'VumikInput',
  inheritAttrs: false,
  inject: [
    'fieldRegister',
    'fieldSetter'
  ],
  props: {
    type: {
      type: String,
      default: 'text'
    },
    name: {
      type: [String, Boolean],
      default: true
    },
    value: {
      default: false
    },
    label: {
      type: [String, Boolean],
      default: false
    },
    desc: {
      type: String,
      required: false
    },
    descPosition: {
      type: String,
      default: 'top'
    }
  },
  data () {
    return {
      proxyValue: this.getInitialValue()
    }
  },
  computed: {
    ...ctx,
    component () {
      return this.$vumik.component(this.type)
    }
  },
  watch: {
    proxyValue (newValue, oldValue) {
      // TODO perform validation
      if (!objEquals(newValue, oldValue)) {
        this.ctx.model = newValue
      }
    }
  },
  created () {
    this.applyInitialValue()
    if (this.fieldRegister && typeof this.fieldRegister === 'function') {
      this.fieldRegister(this.nameOrDefault, this)
    }
  },
  methods: {
    getInitialValue () {
      if (has(this.$options.propsData, 'vumikValue')) {
        return this.vumikValue
      }
      return ''
    },
    applyInitialValue () {
      if (!objEquals(this.ctx.model, this.proxyValue)) {
        this.ctx.model = this.proxyValue
      }
    }
  }
}
</script>
